'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = InputRow;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _InputRow = require('../../styles/cspace-input/InputRow.css');

var _InputRow2 = _interopRequireDefault(_InputRow);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var propTypes = {
  children: _react.PropTypes.node,
  embedded: _react.PropTypes.bool
};

function InputRow(props) {
  var children = props.children,
      embedded = props.embedded;


  var inputContainers = _react2.default.Children.map(children, function (child) {
    return _react2.default.createElement(
      'div',
      null,
      child
    );
  });

  var className = embedded ? _InputRow2.default.embedded : _InputRow2.default.normal;

  return _react2.default.createElement(
    'div',
    { className: className },
    inputContainers
  );
}

InputRow.propTypes = propTypes;