'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _LineInput = require('./LineInput');

var _LineInput2 = _interopRequireDefault(_LineInput);

var _PrefixFilteringDropdownMenuInput = require('./PrefixFilteringDropdownMenuInput');

var _PrefixFilteringDropdownMenuInput2 = _interopRequireDefault(_PrefixFilteringDropdownMenuInput);

var _changeable = require('../enhancers/changeable');

var _changeable2 = _interopRequireDefault(_changeable);

var _committable = require('../enhancers/committable');

var _committable2 = _interopRequireDefault(_committable);

var _withLabeledOptions = require('../enhancers/withLabeledOptions');

var _withLabeledOptions2 = _interopRequireDefault(_withLabeledOptions);

var _KeywordSearchInput = require('../../styles/cspace-input/KeywordSearchInput.css');

var _KeywordSearchInput2 = _interopRequireDefault(_KeywordSearchInput);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var LineInput = (0, _committable2.default)((0, _changeable2.default)(_LineInput2.default));
var PrefixFilteringDropdownMenuInput = (0, _withLabeledOptions2.default)(_PrefixFilteringDropdownMenuInput2.default);

var propTypes = {
  formatRecordTypeLabel: _react.PropTypes.func,
  formatVocabularyLabel: _react.PropTypes.func,
  keywordValue: _react.PropTypes.string,
  placeholder: _react.PropTypes.string,
  recordTypes: _react.PropTypes.object,
  serviceTypeOrder: _react.PropTypes.object,
  recordTypeValue: _react.PropTypes.string,
  vocabularyTypeOrder: _react.PropTypes.object,
  vocabularyValue: _react.PropTypes.string,
  onSearch: _react.PropTypes.func,
  onKeywordCommit: _react.PropTypes.func,
  onRecordTypeCommit: _react.PropTypes.func,
  onVocabularyCommit: _react.PropTypes.func
};

var defaultProps = {
  formatRecordTypeLabel: function formatRecordTypeLabel(name, config) {
    var messages = config.messageDescriptors;

    if (messages && messages.recordNameTitle) {
      return messages.recordNameTitle.defaultMessage;
    }

    return name;
  },
  formatVocabularyLabel: function formatVocabularyLabel(name, config) {
    var messages = config.messageDescriptors;

    if (messages && messages.vocabNameTitle) {
      return messages.vocabNameTitle.defaultMessage;
    }

    return name;
  },
  recordTypes: {},
  serviceTypeOrder: {
    utility: 0,
    object: 1,
    procedure: 2,
    authority: 3
  },
  vocabularyTypeOrder: {
    all: 0
  }
};

var KeywordSearchInput = function (_Component) {
  _inherits(KeywordSearchInput, _Component);

  function KeywordSearchInput() {
    _classCallCheck(this, KeywordSearchInput);

    var _this = _possibleConstructorReturn(this, (KeywordSearchInput.__proto__ || Object.getPrototypeOf(KeywordSearchInput)).call(this));

    _this.handleKeyPress = _this.handleKeyPress.bind(_this);
    _this.handleKeywordInputCommit = _this.handleKeywordInputCommit.bind(_this);
    _this.handleRecordTypeDropdownCommit = _this.handleRecordTypeDropdownCommit.bind(_this);
    _this.handleRecordTypeDropdownUpdate = _this.handleRecordTypeDropdownUpdate.bind(_this);
    _this.handleVocabularyDropdownCommit = _this.handleVocabularyDropdownCommit.bind(_this);
    _this.handleVocabularyDropdownUpdate = _this.handleVocabularyDropdownUpdate.bind(_this);
    return _this;
  }

  _createClass(KeywordSearchInput, [{
    key: 'handleKeywordInputCommit',
    value: function handleKeywordInputCommit(path, value) {
      var onKeywordCommit = this.props.onKeywordCommit;


      if (onKeywordCommit) {
        onKeywordCommit(value);
      }
    }
  }, {
    key: 'handleKeyPress',
    value: function handleKeyPress(event) {
      if (event.key === 'Enter') {
        var onSearch = this.props.onSearch;


        if (onSearch) {
          onSearch();
        }
      }
    }
  }, {
    key: 'handleRecordTypeDropdownCommit',
    value: function handleRecordTypeDropdownCommit(path, value) {
      var onRecordTypeCommit = this.props.onRecordTypeCommit;


      if (onRecordTypeCommit) {
        onRecordTypeCommit(value);
      }
    }
  }, {
    key: 'handleRecordTypeDropdownUpdate',
    value: function handleRecordTypeDropdownUpdate(_ref) {
      var value = _ref.value;

      if (value !== this.props.recordTypeValue) {
        // A default was selected.

        var onRecordTypeCommit = this.props.onRecordTypeCommit;


        if (onRecordTypeCommit) {
          onRecordTypeCommit(value);
        }
      }
    }
  }, {
    key: 'handleVocabularyDropdownCommit',
    value: function handleVocabularyDropdownCommit(path, value) {
      var onVocabularyCommit = this.props.onVocabularyCommit;


      if (onVocabularyCommit) {
        onVocabularyCommit(value);
      }
    }
  }, {
    key: 'handleVocabularyDropdownUpdate',
    value: function handleVocabularyDropdownUpdate(_ref2) {
      var value = _ref2.value;

      if (value !== this.props.vocabularyValue) {
        // A default was selected.

        var onVocabularyCommit = this.props.onVocabularyCommit;


        if (onVocabularyCommit) {
          onVocabularyCommit(value);
        }
      }
    }
  }, {
    key: 'renderRecordTypeDropdown',
    value: function renderRecordTypeDropdown() {
      var _props = this.props,
          formatRecordTypeLabel = _props.formatRecordTypeLabel,
          recordTypes = _props.recordTypes,
          recordTypeValue = _props.recordTypeValue,
          serviceTypeOrder = _props.serviceTypeOrder;


      var sortedRecordTypeNames = Object.keys(recordTypes).sort(function (nameA, nameB) {
        var configA = recordTypes[nameA];
        var configB = recordTypes[nameB];

        // Primary sort by service type

        var serviceTypeA = configA.serviceConfig.serviceType;
        var serviceTypeB = configB.serviceConfig.serviceType;

        if (serviceTypeA !== serviceTypeB) {
          var serviceTypeOrderA = serviceTypeOrder[serviceTypeA];
          var serviceTypeOrderB = serviceTypeOrder[serviceTypeB];

          if (isNaN(serviceTypeOrderA)) {
            serviceTypeOrderA = Number.MAX_VALUE;
          }

          if (isNaN(serviceTypeOrderB)) {
            serviceTypeOrderB = Number.MAX_VALUE;
          }

          if (serviceTypeOrderA !== serviceTypeOrderB) {
            return serviceTypeOrderA > serviceTypeOrderB ? 1 : -1;
          }
        }

        // Secondary sort by sortOrder

        var sortOrderA = configA.sortOrder;
        var sortOrderB = configB.sortOrder;

        if (typeof sortOrderA !== 'number') {
          sortOrderA = Number.MAX_VALUE;
        }

        if (typeof sortOrderB !== 'number') {
          sortOrderB = Number.MAX_VALUE;
        }

        if (sortOrderA !== sortOrderB) {
          return sortOrderA > sortOrderB ? 1 : -1;
        }

        // Final sort by label

        var labelA = formatRecordTypeLabel(nameA, configA);
        var labelB = formatRecordTypeLabel(nameB, configB);

        // FIXME: This should be locale aware
        return labelA.localeCompare(labelB);
      });

      var options = sortedRecordTypeNames.map(function (name, index) {
        var recordType = recordTypes[name];
        var prevRecordType = index === 0 ? null : recordTypes[sortedRecordTypeNames[index - 1]];

        return {
          value: name,
          label: formatRecordTypeLabel(name, recordType),
          startGroup: !prevRecordType || recordType.serviceConfig.serviceType !== prevRecordType.serviceConfig.serviceType
        };
      });

      var value = recordTypeValue;

      if (!value) {
        for (var i = 0; i < sortedRecordTypeNames.length; i += 1) {
          var recordTypeName = sortedRecordTypeNames[i];
          var recordType = recordTypes[recordTypeName];

          if (recordType.defaultForSearch) {
            value = recordTypeName;
            break;
          }
        }

        if (!value && options.length > 0) {
          value = options[0].value;
        }
      }

      return _react2.default.createElement(PrefixFilteringDropdownMenuInput, {
        blankable: false,
        embedded: true,
        options: options,
        value: value,
        onCommit: this.handleRecordTypeDropdownCommit,
        onKeyPress: this.handleKeyPress,
        onMount: this.handleRecordTypeDropdownUpdate,
        onUpdate: this.handleRecordTypeDropdownUpdate
      });
    }
  }, {
    key: 'renderVocabularyDropdown',
    value: function renderVocabularyDropdown() {
      var _props2 = this.props,
          formatVocabularyLabel = _props2.formatVocabularyLabel,
          recordTypes = _props2.recordTypes,
          recordTypeValue = _props2.recordTypeValue,
          vocabularyTypeOrder = _props2.vocabularyTypeOrder,
          vocabularyValue = _props2.vocabularyValue;


      if (!recordTypeValue || !recordTypes[recordTypeValue] || !recordTypes[recordTypeValue].vocabularies) {
        return null;
      }

      var vocabularies = recordTypes[recordTypeValue].vocabularies;

      var sortedVocabularyNames = Object.keys(vocabularies).sort(function (nameA, nameB) {
        var configA = vocabularies[nameA];
        var configB = vocabularies[nameB];

        // Primary sort by group

        var vocabularyTypeA = configA.type;
        var vocabularyTypeB = configB.type;

        if (vocabularyTypeA !== vocabularyTypeB) {
          var vocabularyTypeOrderA = vocabularyTypeOrder[vocabularyTypeA];
          var vocabularyTypeOrderB = vocabularyTypeOrder[vocabularyTypeB];

          if (isNaN(vocabularyTypeOrderA)) {
            vocabularyTypeOrderA = Number.MAX_VALUE;
          }

          if (isNaN(vocabularyTypeOrderB)) {
            vocabularyTypeOrderB = Number.MAX_VALUE;
          }

          if (vocabularyTypeOrderA !== vocabularyTypeOrderB) {
            return vocabularyTypeOrderA > vocabularyTypeOrderB ? 1 : -1;
          }
        }

        // Secondary sort by sortOrder

        var sortOrderA = configA.sortOrder;
        var sortOrderB = configB.sortOrder;

        if (typeof sortOrderA !== 'number') {
          sortOrderA = Number.MAX_VALUE;
        }

        if (typeof sortOrderB !== 'number') {
          sortOrderB = Number.MAX_VALUE;
        }

        if (sortOrderA !== sortOrderB) {
          return sortOrderA > sortOrderB ? 1 : -1;
        }

        // Final sort by label

        var labelA = formatVocabularyLabel(nameA, configA);
        var labelB = formatVocabularyLabel(nameB, configB);

        // FIXME: This should be locale aware
        return labelA.localeCompare(labelB);
      });

      var options = sortedVocabularyNames.map(function (name, index) {
        var vocabulary = vocabularies[name];
        var prevVocabulary = index === 0 ? null : vocabularies[sortedVocabularyNames[index - 1]];

        return {
          value: name,
          label: formatVocabularyLabel(name, vocabulary),
          startGroup: !prevVocabulary || vocabulary.type !== prevVocabulary.type
        };
      });

      var value = vocabularyValue;

      if (!value) {
        for (var i = 0; i < sortedVocabularyNames.length; i += 1) {
          var vocabularyName = sortedVocabularyNames[i];
          var vocabulary = vocabularies[vocabularyName];

          if (vocabulary.defaultForSearch) {
            value = vocabularyName;
            break;
          }
        }

        if (!value && options.length > 0) {
          value = options[0].value;
        }
      }

      return _react2.default.createElement(PrefixFilteringDropdownMenuInput, {
        blankable: false,
        embedded: true,
        options: options,
        value: value,
        onCommit: this.handleVocabularyDropdownCommit,
        onKeyPress: this.handleKeyPress,
        onMount: this.handleVocabularyDropdownUpdate,
        onUpdate: this.handleVocabularyDropdownUpdate
      });
    }
  }, {
    key: 'renderKeywordInput',
    value: function renderKeywordInput() {
      var _props3 = this.props,
          keywordValue = _props3.keywordValue,
          placeholder = _props3.placeholder;


      return _react2.default.createElement(LineInput, {
        embedded: true,
        placeholder: placeholder,
        value: keywordValue,
        onCommit: this.handleKeywordInputCommit,
        onKeyPress: this.handleKeyPress
      });
    }
  }, {
    key: 'render',
    value: function render() {
      return _react2.default.createElement(
        'div',
        { className: _KeywordSearchInput2.default.normal },
        this.renderRecordTypeDropdown(),
        this.renderVocabularyDropdown(),
        this.renderKeywordInput()
      );
    }
  }]);

  return KeywordSearchInput;
}(_react.Component);

exports.default = KeywordSearchInput;


KeywordSearchInput.propTypes = propTypes;
KeywordSearchInput.defaultProps = defaultProps;